// Mozek.cpp: implementation of the Mozek class.
//
//////////////////////////////////////////////////////////////////////
#include <afxwin.h>
#include <stdio.h>
#include "rc\resource.h"
#include "defines.h"
#include "Mozek.h"

 
#define ROZDIL_EX 20
#define ROZDIL_HA 50
#define ROZDIL_ME 300
#define ROZDIL_EA 400 
#define ROZDIL_DE 2000 

#define ROZDIL_DEC 1000
#define ROZDIL 70000
#define _ROZDIL 30000

#define MYSLI_TAH_MIN 3
#define MYSLI_TAH_MAX 7
#define MYSLI_TAH_LIMIT 60000

#define WIN     1000000  // vyhrano
#define LOST     300000  // temer prohrano
#define X4       210000  // utok na 4
#define O4       100000  // obrana na 4
#define X3        39000  // utok na 3
#define O3        32000  // obrana na 3


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

extern Hra h;

CPoint Mozek::Mysli() {
	
	// rozdeleni krizku a kolecek 
	if (h.pocitac == KRIZEK) {
		moje = KRIZEK;
		jeho = KOLECKO;
	}
	else {
		moje = KOLECKO;
		jeho = KRIZEK;
	};

	CPoint kam; // bod, kam hrat

	// urceni obtiznosti
	if (((h.obtiznost_kr == UTOCNIK)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == UTOCNIK)&&(moje == KOLECKO))) kam = Proces_human(); // to je je pro nutnost - aktualni
	
	if (((h.obtiznost_kr == OBRANAR)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == OBRANAR)&&(moje == KOLECKO))) kam = Proces_extreme();
	
	if (((h.obtiznost_kr == DEMO)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == DEMO)&&(moje == KOLECKO))) kam = Proces_demo();
	
	if (((h.obtiznost_kr == HARD)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == HARD)&&(moje == KOLECKO))) kam = Proces_hard();
	
	if (((h.obtiznost_kr == MEDIUM)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == MEDIUM)&&(moje == KOLECKO))) kam = Proces_medium();
	
	if (((h.obtiznost_kr == EASY)&&(moje == KRIZEK)) ||
		 ((h.obtiznost_ko == EASY)&&(moje == KOLECKO))) kam = Proces_easy();

	return kam;
}


CPoint Mozek::Proces_human() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k;
	CPoint po;

	int X = moje;
	int O = jeho;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = (h.plochaX/2) - 10 + Nahoda(20);
		kam.y = (h.plochaY/2) - 10 + Nahoda(20);
		return kam;
	};

	if (h.tah < 5) return Proces_extreme();
	max = 3;
	cnt = -1;
	// init pole
	int rozdil = ROZDIL;
/*	if (h.tah < 5) rozdil = 100;
	cnt = 9;
	while ((cnt > 8)) {
		max = 3;
		cnt = -1;
		if (rozdil > 3) rozdil -= rozdil/4;
		else {
			rozdil = 0;
		}
*/		for (po.x = 5; po.x < h.plochaX+5; po.x++)
			for (po.y = 5; po.y < h.plochaY+5; po.y++) {
				k = Oboduj_pozici(po,X,O);
				if (k >= WIN) return po;
			// zarazeni do moznosti
				if ((k>0)&&(abs(k - max) <= rozdil)&&(cnt < 450)) {
					cnt++;
					body[cnt] = po;
				};
			// nejlepsi moznost - smazani predchozich vysledku
				if ( k > max + rozdil) {
					cnt = 0;
					body[cnt] = po; 
					max = k;
				}
			
			}
//		if ((rozdil < 100)||(cnt < 20 - h.tah)) break;
//	}
	
	// vybrani vysledku
	
	int max_last = max;
	MSG msg;

	if ((h.tah > 2)&&(cnt > 0)) {
		
		h.mysli_tah = 0;
		h.pole[body[0].x][body[0].y] = X;


		AfxGetApp()->m_pMainWnd->SendMessage(WM_PAINT);
		// zparacovani ostatnich zprav
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		};


		max = Boduj_moje(body[0],max_last);
		h.pole[body[0].x][body[0].y] = NIC;
		kam = body[0];

		for(int i = 1; i < cnt+1; i++){
			h.pole[body[i].x][body[i].y] = X;

			AfxGetApp()->m_pMainWnd->SendMessage(WM_PAINT);
			
			// zparacovani ostatnich zprav
			if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			};

			
			if (k = Boduj_jeho(body[i],max_last) < max) {
				max = k;
				kam = body[i];
			}
			h.pole[body[i].x][body[i].y] = NIC;
		};

	}
	else kam = body[Nahoda(cnt+1)];

	AfxGetApp()->m_pMainWnd->SendMessage(WM_PAINT);
	// zparacovani ostatnich zprav
	if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	};


	CString text;
	text.Format("min = %d max_last = %d",max,max_last);
	MessageBox(NULL,text,"",MB_OK);

	return kam;
}

// Velmi dobry hrac
CPoint Mozek::Proces_extreme() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k,m;
	CPoint po;

	int X = moje;
	int O = jeho;
	int N = NIC;
	int C = COKOLI;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = (h.plochaX/2) - 10 + Nahoda(20);
		kam.y = (h.plochaY/2) - 10 + Nahoda(20);
		return kam;
	};
	// init pole
	max = 3;
	cnt = -1;
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) {
			k = 0;
			// vyhrane situace :
			k += 100000 * Hledej(po,X,X,X,X,C);
			k += 100000	* Hledej_inline(po,C,X,X, X,X,C); 	
			k += 100000 * Hledej_inline(po,X,X,X, X,C,C);
			
			// temer smrt
			k +=  80000 * Hledej(po,O,O,O,O,C);  //				*OOOO
			k +=  80000 * Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
			k +=  80000 * Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O

			// temer vyhrane :
			k +=  60000 * Hledej_inline(po,N,X,X, X,N,C);  // _XX*X_
			if (((Hledej(po,X,X,X,N,C) > 0))&&(Hledej_inline(po,C,C,N, X,X,X)>0)) k += 60000; // _XXX*_

			// kriticke situace :
			k +=  50000 * Hledej_inline(po,C,N,O, O,O,N);       //_O*OO_
			if (Hledej_inline(po,C,C,N, O,O,N)>1) k+= 40000; // _*OO_ && _*OO_
			if ((Hledej(po,O,O,O,N,C)>0)&&(Hledej_inline(po,C,C,N, O,O,O)>0)) k += 50000;	// 	_*OOO_
			else if (Hledej(po,O,O,O,C,C)>1) k += 40000;     //  *OOO && *OOO
					else k +=  35000 * Hledej(po,O,O,O,N,C); // *OOO_
			if ((Hledej(po,O,O,O,C,C)>0)&&(Hledej(po,O,O,N,C,C)>0)) k += 30000; // *OOO && *OO_
			if (Hledej_inline(po,N,N,O, O,N,C) > 1) k+= 40000; //					  O	
//																									_O*O__		
//																									  O	
			
			// zajimave situace + pasti :
			if ( k < 40000) {
				if ((Hledej_inline(po,N,N,X, X,N,C)) > 1) k+= 20000; //				  X	
//																										_X*X__		
//																										  X	
				if ((Hledej(po,X,X,X,C,C)>0)&&(Hledej(po,X,X,N,C,C)>0)) k += 20000; // *XXX && *XX_					
				if ((Hledej_inline(po,C,C,N, X,X,N)>0)&&(Hledej_inline(po,C,C,N, N,X,X)>0)) k+= 30000; // _*XX_ &&   _*_XX
				if ((m =  30000 * Hledej(po,X,X,X,N,C)) > 0) k += m ;  // *XXX_
				else if(Nahoda(5) > 3) k +=  25000 * Hledej(po,X,X,X,C,C);  // *XXX
			   k +=   8000 * Hledej_inline(po,N,X,X, X,C,C); // _XX*X 
				if (m = Hledej_inline(po,N,N,O, O,N,N)) k += 2500; // __O*O__
				else k +=   1000 * Hledej_inline(po,C,N,O, O,N,C); //  _O*O_
				if ((m = Hledej_inline(po,C,N,N, O,O,N)) > 1) k+=  5000 * m; // __*OO_
				if ((m = Hledej(po,O,C,C,C,C)>3)) k+= 700; // trochu moc O
			};

			// standart :
			if ((m = Hledej_inline(po,C,C,N, X,X,N))>0) k +=   1000 * m; // _*XX_
			else k +=    500 * Hledej(po,X,X,N,C,C);  // *XX_
			k +=    500 * Hledej(po,N,X,X,C,C);	// *_XX
			k +=    900 * Hledej(po,N,X,N,X,C);	// *_X_X
			k +=   1100 * Hledej_inline(po,C,N,X, X,N,C); // _X*X_
			k +=    500 * Hledej(po,O,O,N,C,C);	// *OO_
			k +=    300 * Hledej(po,X,N,C,C,C); // *X_
			k +=	  200 * Hledej(po,O,N,C,C,C); // *O_
			k +=      5 * Hledej(po,X,C,C,C,C); // *X
			k +=      4 * Hledej(po,O,C,C,C,C); // *O
			
			
			// zarazeni do moznosti
			if ((abs(k - max) <= ROZDIL_HA)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
	
			// nejlepsi moznost - smazani predchozich vysledku
			if ( k > max + ROZDIL_HA) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};
	
	// vybrani vysledku ( nahodne )
	kam = body[Nahoda(cnt+1)]; 
	
	return kam;
}

CPoint Mozek::Proces_hard() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k,m;
	CPoint po;

	int X = moje;
	int O = jeho;
	int N = NIC;
	int C = COKOLI;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = (h.plochaX/2) - 10 + Nahoda(20);
		kam.y = (h.plochaY/2) - 10 + Nahoda(20);
		return kam;
	};
	// init pole
	max = 3;
	cnt = -1;
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) {
			k = 0;
			
			// vyhrane situace
			k += 100000 * Hledej(po,X,X,X,X,C);
			k += 100000	* Hledej_inline(po,C,X,X, X,X,C); 	
			k += 100000 * Hledej_inline(po,X,X,X, X,C,C);
			
			// kriticke situace
			k +=  40000 * Hledej(po,O,O,O,O,C);
			k +=  40000 * Hledej_inline(po,C,O,O, O,O,C);
			k +=  40000 * Hledej_inline(po,O,O,O, O,C,C);

			// specialni situace
			k +=  10000 * Hledej(po,X,X,X,N,C);
			
			if ((k +=  30000 * Hledej_inline(po,N,X,X, X,N,C)) == 0) 
				  k +=   7000 * Hledej_inline(po,N,X,X, X,C,C);
			
			if ((m = Hledej_inline(po,N,N,O, O,N,N)) > 1) k+=  9000 * m; 		
			else k += 8000 * Hledej_inline(po,N,N,O, O,N,N); // bude alespon 2* - symetricke
			
			if ((m = Hledej_inline(po,C,N,N, O,O,N)) > 1) k+=  12000 * m; 		
			else k +=   10000 * Hledej(po,O,O,O,N,C);

			// standartni situace
			k +=   1000 * Hledej(po,X,X,N,C,C);
			k +=   1000 * Hledej_inline(po,C,N,X, X,N,C);
			k +=    500 * Hledej(po,O,O,N,C,C);
			k +=    300 * Hledej(po,X,N,C,C,C);
			k +=      5 * Hledej(po,X,C,C,C,C);
			k +=      4 * Hledej(po,O,C,C,C,C);
			
			if ((abs(k - max) <= ROZDIL_ME)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
			if ( k > max+ROZDIL_ME) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};

	kam = body[Nahoda(cnt+1)];
	return kam;
}

CPoint Mozek::Proces_medium() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k;
	CPoint po;

	int X = moje;
	int O = jeho;
	int N = NIC;
	int C = COKOLI;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = abs((h.plochaX/2) - 10 + Nahoda(20));
		kam.y = abs((h.plochaY/2) - 10 + Nahoda(20));
		return kam;
	};
	// init pole
	max = 3;
	cnt = -1;
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) {
			k = 0;
			// vyhrane situace
			k += 100000 * Hledej(po,X,X,X,X,C);		// *XXXX
			k += 100000	* Hledej_inline(po,C,X,X, X,X,C); // XX*XX
			k += 100000 * Hledej_inline(po,X,X,X, X,C,C);	// XXX*X
			
			// kriticke situace - trocha nahody, aby slo snaze vyhrat
			k +=  40000 * Hledej(po,O,O,O,O,C);  // *OOOO
			if (Nahoda(5) > 1) k +=  40000 * Hledej_inline(po,C,O,O, O,O,C); // OO*OO
			if (Nahoda(5) > 1) k +=  40000 * Hledej_inline(po,O,O,O, O,C,C); // OOO*O
			
			
			// temer vyhrane :
			if (Nahoda(8) > 1)
				if ((k +=  20000 * Hledej_inline(po,N,X,X, X,N,C)) == 0) // _XX*X_
					  k +=   9000 * Hledej_inline(po,N,X,X, X,C,C); // _XX*X

			// zvlastni situace :
			k +=  9000 * Hledej(po,X,X,X,N,C); // *XXX_
				
			// standartni situace 
				// obrana
			if (Nahoda(8) > 3) k += 2000 * Hledej_inline(po,N,N,O, O,N,N); // __O*O__
			if (Nahoda(5) > 1) k +=  2000 * Hledej(po,O,O,O,N,C); // *OOO_
				// utok
			if (Nahoda(8) > 6) k +=  1000 * Hledej_inline(po,C,C,N, X,X,N); // _*XX_
			else k +=   600 * Hledej(po,X,X,N,C,C); // *XX_
			k +=   1000 * Hledej_inline(po,C,N,X, X,N,C); // _X*X_
				
				// odpad
			if (Nahoda(8) > 5) k +=    500 * Hledej(po,O,O,N,C,C); // *OO_
			k +=    300 * Hledej(po,X,N,C,C,C);	// *X_
			k +=      6 * Hledej(po,X,C,C,C,C);	// *X
			k +=      5 * Hledej(po,O,C,C,C,C); // *O

			if ((abs(k - max) <= ROZDIL_ME)&&(cnt < 450)&&(k>0)){
				cnt++;
				body[cnt] = po;
			};
			if ( k > max+ROZDIL_ME) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};

	kam = body[Nahoda(cnt+1)];
	return kam;
}

CPoint Mozek::Proces_easy() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k;
	CPoint po;

	int X = moje;
	int O = jeho;
	int N = NIC;
	int C = COKOLI;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = (h.plochaX/2) - 10 + Nahoda(20);
		kam.y = (h.plochaY/2) - 10 + Nahoda(20);
		return kam;
	};
	// init pole
	max = 3;
	cnt = -1;
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) {
			k = 0;
			// vyhrane situce :
			if (Nahoda(8) > 1) k += 100000 * Hledej(po,X,X,X,X,C);
			if (Nahoda(8) > 2) k += 100000	* Hledej_inline(po,C,X,X, X,X,C);	
			if (Nahoda(8) > 2) k += 100000 * Hledej_inline(po,X,X,X, X,C,C);
			
			// kriticke situace :
			if (Nahoda(20) > 3)k +=  40000 * Hledej(po,O,O,O,O,C);
			if (Nahoda(5) > 2) k +=  40000 * Hledej_inline(po,C,O,O, O,O,C);
			if (Nahoda(5) > 2) k +=  40000 * Hledej_inline(po,O,O,O, O,C,C);

			// zvlastni situace :
			k +=  9000 * Hledej(po,X,X,X,N,C);
			if (Nahoda(8) > 5)
				if ((k +=  18000 * Hledej_inline(po,N,X,X, X,N,C)) == 0) 
					  k +=   7000 * Hledej_inline(po,N,X,X, X,C,C);
			
			// standartni situace :
			if (Nahoda(8) > 5) k += 1000 * Hledej_inline(po,N,N,O, O,N,N); // bude alespon 2* - symetricke
			
			if (Nahoda(5) > 2) k +=  10000 * Hledej(po,O,O,O,N,C);
			if (Nahoda(8) > 6) k +=   1000 * Hledej(po,X,X,N,C,C);
			else k +=   500 * Hledej(po,X,X,N,C,C);

			k +=   1000 * Hledej_inline(po,C,N,X, X,N,C);
			if (Nahoda(8) > 6) k +=    900 * Hledej(po,O,O,N,C,C);
			k +=    300 * Hledej(po,X,N,C,C,C);
			k +=      5 * Hledej(po,X,C,C,C,C);
			k +=      6 * Hledej(po,O,C,C,C,C);
		
			// zarazeni do pole
			if ((abs(k - max)<ROZDIL_EA)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
			if ( k > max) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};
	
	// urceni vysledku
	kam = body[Nahoda(cnt+1)];
	return kam;
}

// Demo - postaveno velmi na obranu
CPoint Mozek::Proces_demo() {
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k,m;
	CPoint po;

	int X = moje;
	int O = jeho;
	int N = NIC;
	int C = COKOLI;

	if (h.tah == 0) { // zpracovani 1. tahu
		kam.x = (h.plochaX/2) - 10 + Nahoda(20);
		kam.y = (h.plochaY/2) - 10 + Nahoda(20);
		return kam;
	};
	// init pole
	max = 3;
	cnt = -1;
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) {
			k = 0;
			// vyhrane situace :
			k -= 20000 * Hledej(po,X,X,X,X,C);
			k -= 10000	* Hledej_inline(po,C,X,X, X,X,C); 	
			k -= 10000 * Hledej_inline(po,X,X,X, X,C,C);
			
			// temer vyhrane : - odebrany, aby demo trvalo dele

			// kriticke situace :
			k +=  80000 * Hledej(po,O,O,O,O,C);  //				*OOOO
			k +=  80000 * Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
			k +=  80000 * Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O
			if ((Hledej(po,O,O,O,N,C)>0)&&(Hledej_inline(po,C,C,N, O,O,O)>0)) k += 80000;	// 	_*OOO_
			if ((Hledej(po,O,O,O,C,C)>0)&&(Hledej(po,O,O,N,C,C)>0)) k += 60000; // *OOO && *OO_
			if (Hledej_inline(po,C,N,O, O,O,N)>0) k += 80000;       //_O*OO_ 
			if ((Hledej_inline(po,C,C,N, O,O,N)>0)&&(Hledej_inline(po,C,C,N, N,O,O)>0)) k+= 80000; // _*OO_ && _*_OO
			if (Hledej_inline(po,N,N,O, O,N,C) > 1) k+= 80000; //					  O	
//																									_O*O__		
//																									  O	
			
			// zajimave situace + pasti :
			if ( k < 4000) {
				k +=  500 * Hledej(po,X,X,X,N,C);  // *XXX_
			   k +=   300 * Hledej_inline(po,N,X,X, X,C,C); // _XX*X 
				k +=  20000 * Hledej_inline(po,C,N,O, O,N,C); //  _O*O_
				k +=  19000 * Hledej(po,O,O,O,N,C);	// *OOO_
				if ((m = Hledej_inline(po,C,N,N, O,O,N)) > 1) k+= 19000 * m; // __*OO_
				if ((m = Hledej(po,O,C,C,C,C)>3)) k+= 6000; // trochu moc O
			};

			// standart :
			k +=   700 * Hledej(po,X,X,N,C,C);  // *XX_
			k +=   700 * Hledej(po,N,X,X,C,C);	// *_XX
			k +=   700 * Hledej(po,N,X,N,X,C);	// *_X_X
			k +=   800 * Hledej_inline(po,C,N,X, X,N,C); // _X*X_
			k +=   15000 * Hledej(po,O,O,N,C,C);	// *OO_
			k +=    300 * Hledej(po,X,N,C,C,C); // *X_
			k +=	  6000 * Hledej(po,O,N,C,C,C); // *O_
			k +=      50 * Hledej(po,X,C,C,C,C); // *X
			k +=      90 * Hledej(po,O,C,C,C,C); // *O
			
			
			// zarazeni do moznosti
			if ((abs(k - max) <= ROZDIL_DE)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
	
			// nejlepsi moznost - smazani predchozich vysledku
			if ( k > max + ROZDIL_EX) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};
	
	// vybrani vysledku ( nahodne )
	kam = body[Nahoda(cnt+1)]; 
	
	return kam;
}


// vrati pocet zadanych moznosti ve vsech smerech
int Mozek::Hledej(CPoint pt,int p,int d, int t, int c, int s) {
	int pocet = 0;
	
	//  * ? ? ? ? ?
	// * p d t c s
	// * = zadany bod
	// nema smysl premyslet
	if (h.pole[pt.x][pt.y] != NIC) return 0;

// vertikalne :	
	// nahoru :
	if (((h.pole[pt.x][pt.y-1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// dolu:
	if (((h.pole[pt.x][pt.y+1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+5]==s)||(s==COKOLI))) pocet++;
	
// horizontalne :
	// doleva :
	if (((h.pole[pt.x-1][pt.y]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x-4][pt.y]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x-5][pt.y]==s)||(s==COKOLI))) pocet++;
	 
	// doprava :
	if (((h.pole[pt.x+1][pt.y]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x+3][pt.y]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x+4][pt.y]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x+5][pt.y]==s)||(s==COKOLI))) pocet++;	

// 1. diagonala :
	// doleva nahor :
	if (((h.pole[pt.x-1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x-4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x-5][pt.y-5]==s)||(s==COKOLI))) pocet++;
	
	// doprava dolu :
	if (((h.pole[pt.x+1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x+3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x+4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x+5][pt.y+5]==s)||(s==COKOLI))) pocet++;

// 2. diagonala :
	// doprava dolu :
	if (((h.pole[pt.x-1][pt.y+1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y+2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y+3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x-4][pt.y+4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x-5][pt.y+5]==s)||(s==COKOLI))) pocet++;

	// doprava nahoru :
	if (((h.pole[pt.x+1][pt.y-1]==p)||(p==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y-2]==d)||(d==COKOLI)) &&
		 ((h.pole[pt.x+3][pt.y-3]==t)||(t==COKOLI)) &&
		 ((h.pole[pt.x+4][pt.y-4]==c)||(c==COKOLI)) &&
		 ((h.pole[pt.x+5][pt.y-5]==s)||(s==COKOLI))) pocet++;

	return pocet;
}

int Mozek::Hledej_inline(CPoint pt,int l3,int l2, int l1, int p1, int p2, int p3) {
	int pocet = 0;

   // aby se jedno moznost nepocitala 2* -> zdvojeni ifu - [symetricke zadani]
	// ? ? ? * ? ? ?
	// l3 l2 l1 * p1 p2 p3
	// * = zadany bod
	// nema smysl premyslet
	if (h.pole[pt.x][pt.y] != NIC) return 0;

// vertikalne :
	// nahoru l:
	if (((h.pole[pt.x][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((h.pole[pt.x][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// dolu l:
	if (((h.pole[pt.x][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((h.pole[pt.x][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((h.pole[pt.x][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;

// vertikalne :
	// doleva l:
	if (((h.pole[pt.x-1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y]==l2)||(l2==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y]==l3)||(l3==COKOLI)) &&
		 ((h.pole[pt.x+1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y]==p2)||(p2==COKOLI)) && 
		 ((h.pole[pt.x+3][pt.y]==p3)||(p3==COKOLI)) ) pocet++;
	else 
	// doprava l:
	if (((h.pole[pt.x-1][pt.y]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y]==p2)||(p2==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y]==p3)||(p3==COKOLI)) &&
		 ((h.pole[pt.x+1][pt.y]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y]==l2)||(l2==COKOLI)) && 
		 ((h.pole[pt.x+3][pt.y]==l3)||(l3==COKOLI)) ) pocet++;

// 1. diagonala :
	// doleva nahoru l:
	if (((h.pole[pt.x-1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((h.pole[pt.x+1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((h.pole[pt.x+3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;
	else
	// doprava dolu l:
	if (((h.pole[pt.x-1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((h.pole[pt.x-3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((h.pole[pt.x+1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((h.pole[pt.x+3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	
// 2. diagonala :
	// doprava nahoru l:
	if (((h.pole[pt.x+1][pt.y-1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y-2]==p2)||(p2==COKOLI)) &&
		 ((h.pole[pt.x+3][pt.y-3]==p3)||(p3==COKOLI)) &&
		 ((h.pole[pt.x-1][pt.y+1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y+2]==l2)||(l2==COKOLI)) && 
		 ((h.pole[pt.x-3][pt.y+3]==l3)||(l3==COKOLI)) ) pocet++;
	else 
	// doleva dolu l:
	if (((h.pole[pt.x+1][pt.y-1]==l1)||(l1==COKOLI)) &&
		 ((h.pole[pt.x+2][pt.y-2]==l2)||(l2==COKOLI)) &&
		 ((h.pole[pt.x+3][pt.y-3]==l3)||(l3==COKOLI)) &&
		 ((h.pole[pt.x-1][pt.y+1]==p1)||(p1==COKOLI)) &&
		 ((h.pole[pt.x-2][pt.y+2]==p2)||(p2==COKOLI)) && 
		 ((h.pole[pt.x-3][pt.y+3]==p3)||(p3==COKOLI)) ) pocet++;

	return pocet;
}

// Funkce hod kostkou a vrt nhodn slo
// Funguje pro kostku s libovolnm potem stran
int Mozek::Nahoda(int kolik) {
	int testpoint;
	int r = rand();			// rand() vypot nhodn slo v rozsahu  a0x7FFF

	// konstanta RAND_MAX je definovna ve stdio.h na 0x07FFF
	if (kolik == 0) kolik++;
	int breakpoint = RAND_MAX / kolik;  // rozdl RAND_MAX 
	
	//  na rovnomrn dly
	for (int c = 1; c < kolik; c++) {	// Testuje kad rozsah
		testpoint = c * breakpoint;
		if (r < testpoint)
			break;		 // konec pi nalezen
	}	
	c--;
	return (c);	// vrt slo hodu bez 1
	
	return 5;
}

// *********************************************************************************************************
// *********************************************************************************************************




// *********************************************************************************************************
// *********************************************************************************************************


long Mozek::Boduj_moje(CPoint point, int last){
	
	int X = moje;
	int O = jeho;
	
	if ((h.mysli_tah >= MYSLI_TAH_MAX) ||
		((h.mysli_tah > MYSLI_TAH_MIN)&&(h.mysli_tah*MYSLI_TAH_LIMIT > last))) {

		h.pole[point.x][point.y] = NIC;
		return Oboduj_pozici_vysledne(point,O,X);
		}

	
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	int min;
	long k;
	CPoint po;

	// init pole
	int rozdil = _ROZDIL;
	if (h.tah < 5) rozdil = 100;
	cnt = 9;
	while ((cnt > 8)) {
		max = 3;
		cnt = -1;
		if (rozdil > 3) rozdil -= rozdil/4;
		else {
			rozdil = 0;
		}
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) 
		if(h.pole[po.x][po.y] == NIC)
		{
			k = Oboduj_pozici(po,X,O);
			if (k >=	WIN) {
				return -k;
			};
			// zarazeni do moznosti
			if ((abs(k - max) <= rozdil)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
	
			// nejlepsi moznost - smazani predchozich vysledku
			if ( k > max + rozdil) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			};
		};
		if(rozdil < 90) break;
	}
	

	if (cnt == -1) return 100000;  // remiza

	h.mysli_tah++;

	int max_last = max + last;

	h.pole[body[0].x][body[0].y] = X;
	min = Boduj_jeho(body[0],max_last);
	h.pole[body[0].x][body[0].y] = NIC;
	
	for(int i = 1; i < cnt+1; i++){
		h.pole[body[i].x][body[i].y] = X;
		k = Boduj_jeho(body[i],max_last);
		h.pole[body[i].x][body[i].y] = NIC;
		if (k < min) min = k;
	};
	h.mysli_tah--;
	return min;
	
}


// **************************************************************************************************
// ***********************************  Boduj_jeho(CPoint point)  ***********************************

long Mozek::Boduj_jeho(CPoint point, int last){

	int X = moje;
	int O = jeho;
/*	
	if ((h.mysli_tah >= MYSLI_TAH_MAX) ||
		((h.mysli_tah > MYSLI_TAH_MIN)&&(h.mysli_tah*MYSLI_TAH_LIMIT > last))) {
			h.pole[point.x][point.y] = NIC;
			return Oboduj_pozici_vysledne(point,X,O);
		}

*/
	CPoint kam;
	signed int cnt;
	CPoint body[500];
	int max;
	long k;
	CPoint po;
	
	// init pole
	int rozdil = _ROZDIL;
	if (h.tah < 5) rozdil = 100;
	cnt = 9;
	while ((cnt > 8)) {
		max = 3;
		cnt = -1;
		if (rozdil > 3) rozdil -= rozdil/4;
		else {
			rozdil = 0;
		}
	for (po.x = 5; po.x < h.plochaX+5; po.x++)
		for (po.y = 5; po.y < h.plochaY+5; po.y++) 
		if(h.pole[po.x][po.y] == NIC)
		{
			k = Oboduj_pozici(po,O,X);

			if (k >=	WIN) return k;
			
			// zarazeni do moznosti
			if ((abs(k - max) <= rozdil)&&(cnt < 450)&&(k>0)) {
				cnt++;
				body[cnt] = po;
			};
	
			// nejlepsi moznost - smazani predchozich vysledku
			if (( k > max + rozdil)&&(k > 0)) {
				cnt = 0;
				body[cnt] = po; 
				max = k;
			}
		}
		if (rozdil < 100) break;
	}


	if (cnt == -1) return 100000;  // remiza

	h.mysli_tah++;
	int max_last = last + max;
	// vybrani vysledku ( nahodne )
	h.pole[body[0].x][body[0].y] = O;
	k = Boduj_moje(body[0],max_last);
	max = k;
	h.pole[body[0].x][body[0].y] = NIC;
	for(int i = 1; i < cnt+1; i++){
		h.pole[body[i].x][body[i].y] = O;
		k = Boduj_moje(body[i],max_last);
		h.pole[body[i].x][body[i].y] = NIC;
		if (k > max) max = k;
	};
	h.mysli_tah--;


	if (max == 0) {
//	MessageBox(NULL,"ERROR","",MB_OK);
	}

	return max;
}

// ***************************************************************************************************
// ***********************************  Oboduj_pozici(CPoint po, int X, int O)  **********************

long Mozek::Oboduj_pozici(CPoint po, int X, int O){
	
	int N = NIC;
	int C = COKOLI;

	long k = 0;
	long m;

		// vyhrane situace :
	k += WIN * Hledej(po,X,X,X,X,C);
	k += WIN	* Hledej_inline(po,C,X,X, X,X,C); 	
	k += WIN * Hledej_inline(po,X,X,X, X,C,C);
			
		// temer smrt : nutne
	k += LOST * Hledej(po,O,O,O,O,C);  //				*OOOO
	k += LOST * Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
	k += LOST * Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O


		// temer vyhrane ( opak prohranych na 4 )
	k +=  X4 * Hledej_inline(po,N,X,X, X,N,C);  // _XX*X_
	if (((Hledej(po,X,X,X,N,C) > 0))&&(Hledej_inline(po,C,C,N, X,X,X)>0)) k += 190000; // _XXX*_
	
	// kmbinator
	m = 0;
	m +=  Hledej(po,X,X,X,N,C);		    //  *XXX_
	if (m == 0) 								 //  _*XXX
		m += Hledej_inline(po,X,X,X, N,C,C);

	m += Hledej(po,N,X,X,X,C);				 //  *_XXX

	if (m > 0) {
		if(Hledej(po,N,X,X,N,C)&&Hledej_inline(po,C,C,N, N,X,X)) m++;//  _*_XX_
		if(Hledej(po,X,N,X,N,C)&&Hledej_inline(po,C,C,N, X,N,X)) m++;// _*X_X_
		m += Hledej_inline(po,X,X,N, N,C,C); // _*XX_
		m += Hledej_inline(po,N,N,X, X,N,C); // _X*X__
	};
	
	k += m*(X4/2); // aby melo ucinek - musi byt alespon 2*
//	if (m == 0) k += 600 * Hledej(po,N,X,X,X,C);	//  *_XXX

		// kriticke situace na 4	:
	k +=  O4 * Hledej_inline(po,N,O,O, O,N,C);  // _OO*O_
	if (((Hledej(po,O,O,O,N,C) > 0))&&(Hledej_inline(po,C,C,N, O,O,O)>0)) k += 80000; // _OOO*_
// kmbinator
	m = 0;
	m +=  Hledej(po,O,O,O,N,C);		    //  *OOO_
	if (m == 0) 								 //  _*OOO
		m += Hledej_inline(po,O,O,O, N,C,C);
	
	//m += Hledej(po,N,O,O,O,C);				 //  *_OOO

	if (m > 0) {
	//	if(Hledej(po,N,O,O,N,C)&&Hledej_inline(po,C,C,N, N,O,O)) m++;//  _*_OO_
		if(Hledej(po,O,N,O,N,C)&&Hledej_inline(po,C,C,N, O,N,O)) m++;// _*O_O_
		m += Hledej_inline(po,O,O,N, N,C,C); // _*OO_
		m += Hledej_inline(po,N,N,O, O,N,C); // _O*O__
	};

	k += (O4/2)*m;

		//	Utok na 3 :
	m = 0;
	m += Hledej_inline(po,N,N,X, X,N,C);  // _X*X__		
	m += Hledej_inline(po,C,C,N, X,X,N);  // _*XX_
	if (Hledej(po,X,X,X,N,C)||Hledej_inline(po,C,C,N, X,X,X)) m++; // *XXX_ || _*XXX
	if(Hledej(po,X,N,X,N,C)&&Hledej_inline(po,C,C,N, X,N,X)) m++;// _*X_X_

	if (m > 0) {
		if (Hledej(po,X,X,N,C,C)>1) m++;				 //  *XX_
		if(Hledej(po,N,X,X,N,C)&&Hledej_inline(po,C,C,N, N,X,X)) m++;//  _*_XX_
	}
	k += X3 * m;

		// Obrana na 3 :		
	m = 0;
	m += Hledej_inline(po,N,N,O, O,N,C);  // _O*O__		
	m += Hledej_inline(po,C,C,O, O,O,N);  // _*OO_
	k += O3 * m;


			// standart :
	k +=   1900 * Hledej(po,X,X,N,C,C);  // *XX_
	k +=    600 * Hledej(po,X,N,X,C,C);	// *X_X
	k +=    500 * Hledej(po,O,O,N,C,C);	// *OO_
	k +=    600 * Hledej(po,X,N,C,C,C); // *X_
	k +=	  200 * Hledej(po,O,N,C,C,C); // *O_
	k +=     50 * Hledej(po,X,C,C,C,C); // *X
	k +=     40 * Hledej(po,O,C,C,C,C); // *O

	return k;

}

//********************* oboduj pozici vysledne

long Mozek::Oboduj_pozici_vysledne(CPoint po, int X, int O){
	
	int N = NIC;
	int C = COKOLI;

	long k = 0;
	long m;

		// vyhrane situace :
	k += WIN * Hledej(po,X,X,X,X,C);
	k += WIN	* Hledej_inline(po,C,X,X, X,X,C); 	
	k += WIN * Hledej_inline(po,X,X,X, X,C,C);
			
		// temer smrt : nutne
	k -= LOST * Hledej(po,O,O,O,O,C);  //				*OOOO
	k -= LOST * Hledej_inline(po,C,O,O, O,O,C);  //  OO*OO
	k -= LOST * Hledej_inline(po,O,O,O, O,C,C);  //  OOO*O


		// temer vyhrane ( opak prohranych na 4 )
	k +=  X4 * Hledej_inline(po,N,X,X, X,N,C);  // _XX*X_
	if (((Hledej(po,X,X,X,N,C) > 0))&&(Hledej_inline(po,C,C,N, X,X,X)>0)) k += 190000; // _XXX*_
	
	// kmbinator
	m = 0;
	m +=  Hledej(po,X,X,X,N,C);		    //  *XXX_
	if (m == 0) 								 //  _*XXX
		m += Hledej_inline(po,X,X,X, N,C,C);
	if (m > 0) {
		m += Hledej(po,N,X,X,X,C);				 //  *_XXX
		if(Hledej(po,N,X,X,N,C)&&Hledej_inline(po,C,C,N, N,X,X)) m++;//  _*_XX_
		m += Hledej_inline(po,X,X,N, N,C,C); // _*XX_
		m += Hledej_inline(po,N,N,X, X,N,C); // _X*X__
	};
	
	k += X4/3; // aby melo ucinek - musi byt alespon 2*
//	if (m == 0) k += 600 * Hledej(po,N,X,X,X,C);	//  *_XXX


		// kriticke situace na 4	:
	k -=  O4 * Hledej_inline(po,N,O,O, O,N,C);  // _OO*O_
	if (((Hledej(po,O,O,O,N,C) > 0))&&(Hledej_inline(po,C,C,N, O,O,O)>0)) k -= O4; // _OOO*_
// kmbinator
	m = 0;
	m +=  Hledej(po,O,O,O,N,C);		    //  *OOO_
	if (m == 0) 								 //  _*OOO
		m += Hledej_inline(po,O,O,O, N,C,C);
	if (m > 0) {
		if(Hledej(po,N,O,O,N,C)&&Hledej_inline(po,C,C,N, N,O,O)) m++;//  _*_OO_
		m += Hledej_inline(po,O,O,N, N,C,C); // _*OO_
		m += Hledej_inline(po,N,N,O, O,N,C); // _O*O__
		m += Hledej(po,N,O,O,O,C);				 //  *_OOO
	};

	if (m > 1) k -= O4;

		//	Utok na 3 :
	m = 0;
	m += Hledej_inline(po,N,N,X, X,N,C);  // _X*X__		
	m += Hledej_inline(po,C,C,N, X,X,N);  // _*XX_
	if (Hledej(po,X,X,X,N,C)||Hledej_inline(po,C,C,N, X,X,X)) m++; // *XXX_ || _*XXX
	if (m > 0) {
		if (Hledej(po,X,X,N,C,C)>1) m++;				 //  *XX_

	}
	k += X3 * m;

		// Obrana na 3 :		
	m = 0;
	m += Hledej_inline(po,N,N,O, O,N,C);  // _O*O__		
	m += Hledej_inline(po,C,C,O, O,O,N);  // _*OO_
	k -= O3 * m;


			// standart :
	k +=   1900 * Hledej(po,X,X,N,C,C);  // *XX_
	k +=    600 * Hledej(po,X,N,X,C,C);	// *X_X
	k -=    500 * Hledej(po,O,O,N,C,C);	// *OO_
	k +=    600 * Hledej(po,X,N,C,C,C); // *X_
	k -=	  200 * Hledej(po,O,N,C,C,C); // *O_
	k +=     50 * Hledej(po,X,C,C,C,C); // *X
	k +=     40 * Hledej(po,O,C,C,C,C); // *O

	return k;

}

